Debian Bug report logs - #593561
Re-runs include @aptsources in bootstrap phase

version graph

Package: multistrap; Maintainer for multistrap is Neil Williams <codehelp@debian.org>; Source for multistrap is src:multistrap.

Reported by: "Trent W. Buck" <trentbuck@gmail.com>

Date: Thu, 19 Aug 2010 09:36:02 UTC

Severity: important

Tags: confirmed

Found in version multistrap/2.1.6

Fixed in version multistrap/2.1.8

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#593561; Package multistrap. (Thu, 19 Aug 2010 09:36:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Trent W. Buck" <trentbuck@gmail.com>:
New Bug report received and forwarded. Copy sent to Neil Williams <codehelp@debian.org>. (Thu, 19 Aug 2010 09:36:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Trent W. Buck" <trentbuck@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Re-runs include @aptsources in bootstrap phase
Date: Thu, 19 Aug 2010 19:34:23 +1000
Package: multistrap
Version: 2.1.6
Severity: minor

Consider the case where multistrap.conf contains:

    [General]
    debootstrap=Y
    aptsources=X
    [...]

The user

    1. runs multistrap to succesful completion
    2. realizes that she forgot to include "mg"
    3. adds "mg" to packages= line in multistrap.conf
    4. re-runs multistrap

At this point, multistrap will be attempting to bootstrap while
sources.d contains BOTH multistrap-X.conf (from the first run) and
multistrap-Y.conf (from the second run).

If Y is a file: repo and X is an http repo, this can make the second
run take longer / download more than it needs to.

To work around this, I run the following prior to each multistrap run.
If this doesn't conflict with the "stateless" approach, it could be
done in multistrap.

    rm -f $dir/etc/apt/sources.d/multistrap-*.conf

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.35 (SMP w/2 CPU cores)
Locale: LANG=en_AU.utf8, LC_CTYPE=en_AU.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages multistrap depends on:
ii  apt                           0.7.25.3   Advanced front-end for dpkg
ii  libconfig-auto-perl           0.20-2     Magical config file parser
ii  libparse-debian-packages-perl 0.01-2     parse the data from a Debian Packa
ii  perl                          5.10.1-14  Larry Wall's Practical Extraction 
ii  realpath                      1.15       Return the canonicalized absolute 

Versions of packages multistrap recommends:
ii  emdebian-archive-keyring      2.0.1      GnuPG archive keys for the emdebia

Versions of packages multistrap suggests:
ii  fakeroot                      1.14.4-1   Gives a fake root environment

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#593561; Package multistrap. (Thu, 19 Aug 2010 10:39:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. (Thu, 19 Aug 2010 10:39:08 GMT) Full text and rfc822 format available.

Message #10 received at 593561@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: "Trent W. Buck" <trentbuck@gmail.com>, 593561@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#593561: Re-runs include @aptsources in bootstrap phase
Date: Thu, 19 Aug 2010 11:34:16 +0100
[Message part 1 (text/plain, inline)]
tag 593561 + confirmed
tag 593561 + pending
severity 593561 important
thanks

On Thu, 19 Aug 2010 19:34:23 +1000
"Trent W. Buck" <trentbuck@gmail.com> wrote:

> Consider the case where multistrap.conf contains:
> 
>     [General]
>     debootstrap=Y
>     aptsources=X
>     [...]
> The user
> 
>     1. runs multistrap to succesful completion
>     2. realizes that she forgot to include "mg"
>     3. adds "mg" to packages= line in multistrap.conf
>     4. re-runs multistrap
> 
> At this point, multistrap will be attempting to bootstrap while
> sources.d contains BOTH multistrap-X.conf (from the first run) and
> multistrap-Y.conf (from the second run).

That sounds like a bug. If a source is not included in the bootstrap
option, it should not be accessible to the bootstrap operation, only
the subsequent apt sources.

> If Y is a file: repo and X is an http repo, this can make the second
> run take longer / download more than it needs to.
> 
> To work around this, I run the following prior to each multistrap run.
> If this doesn't conflict with the "stateless" approach, it could be
> done in multistrap.
> 
>     rm -f $dir/etc/apt/sources.d/multistrap-*.conf

Multistrap should do that itself - indeed it should probably extend
that to rm -f $dir/etc/apt/sources.d/* 

It already tries to do this:
unlink ("${dir}etc/apt/sources.list.d/multistrap.sources.list")
	if (-f "${dir}etc/apt/sources.list.d/multistrap.sources.list");
unlink ("${dir}etc/apt/sources.list")
	if (-f "${dir}etc/apt/sources.list");

I'll extend that so that ${dir}etc/apt/sources.list.d/ is empty at the
start of each multistrap run - stateless doesn't mean that multistrap
can afford to ignore / undermine it's own configuration settings.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.linux.codehelp.co.uk/
http://e-mail.is-not-s.ms/

[Message part 2 (application/pgp-signature, inline)]

Added tag(s) confirmed. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 19 Aug 2010 10:39:10 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 19 Aug 2010 10:39:10 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'minor' Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 19 Aug 2010 10:39:11 GMT) Full text and rfc822 format available.

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Sat, 16 Oct 2010 15:03:19 GMT) Full text and rfc822 format available.

Notification sent to "Trent W. Buck" <trentbuck@gmail.com>:
Bug acknowledged by developer. (Sat, 16 Oct 2010 15:03:19 GMT) Full text and rfc822 format available.

Message #21 received at 593561-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 593561-close@bugs.debian.org
Subject: Bug#593561: fixed in multistrap 2.1.8
Date: Sat, 16 Oct 2010 15:02:18 +0000
Source: multistrap
Source-Version: 2.1.8

We believe that the bug you reported is fixed in the latest version of
multistrap, which is due to be installed in the Debian FTP archive:

multistrap_2.1.8.dsc
  to main/m/multistrap/multistrap_2.1.8.dsc
multistrap_2.1.8.tar.gz
  to main/m/multistrap/multistrap_2.1.8.tar.gz
multistrap_2.1.8_all.deb
  to main/m/multistrap/multistrap_2.1.8_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 593561@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated multistrap package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 16 Oct 2010 15:36:06 +0100
Source: multistrap
Binary: multistrap
Architecture: source all
Version: 2.1.8
Distribution: experimental
Urgency: low
Maintainer: Neil Williams <codehelp@debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 multistrap - multiple repository bootstrap based on apt
Closes: 592621 593326 593561 595006 599056
Changes: 
 multistrap (2.1.8) experimental; urgency=low
 .
   [ Wookey ]
   * Add support for 'flat' apt-ftparchive-style URLs
   * Include chroot.sh preventing services being started during
     chroot creation (Closes: #599056)
 .
   [ Neil Williams ]
   * Improve the omitdebsrc handling for detection of 'true'.
   * Add more synopsis information to manual page. (Closes: #592621)
   * Aim 2.1.8 at experimental as squeeze is frozen and this version
     includes possibly disruptive changes.
   * Remove aptsources lists in bootstrap phase (Closes: #593561)
   * Improve check-deps to find missing packages
   * Drop all use of forceyes - no longer necessary.
   * Handle missing 'include' files cleanly and early. (Closes: #595006)
   * Expand the --simulate option output further.
   * Document the reinstall and additional fields. Add advice in manpage
     on what to check before filing bugs.
   * Add a note about redirecting output in manpage. (Closes: #593326)
   * Bump to debhelper 7 compat for dh_prep usage.
Checksums-Sha1: 
 52c8876ad7bfadff2a62e5638cc813b23d23ee63 1018 multistrap_2.1.8.dsc
 30910515e85325ba226535872662369e18cbe2e6 141303 multistrap_2.1.8.tar.gz
 a18ea82f821dbdc26122d0a2071021bc8a497aeb 86122 multistrap_2.1.8_all.deb
Checksums-Sha256: 
 9aa030e36f6eae1b1b56f30ea72f1b1f26287748ba9799162574bb5b7a268e95 1018 multistrap_2.1.8.dsc
 02803b7e3101559388bd60a2e37d308c7da4dea27217a424f836645dba035bc6 141303 multistrap_2.1.8.tar.gz
 b8df363142eae1f2df2f1962f9e6115d47f5c2226dc16682ed6ccf0af8d0a441 86122 multistrap_2.1.8_all.deb
Files: 
 f51a3dd648e712c29cdbd6b9fb010277 1018 utils optional multistrap_2.1.8.dsc
 dee6dcef9ffb9fa91d65c8a73658d370 141303 utils optional multistrap_2.1.8.tar.gz
 80f6abe534a6da07773774b73795f92f 86122 admin optional multistrap_2.1.8_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAky5uVwACgkQiAEJSii8s+PP7QCg4MK+1dJCfiui4eexYhBoYE+G
wyIAoKz81pRTEaeyX9Qn9I5SXw51R/CR
=wL1r
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 20 Mar 2011 07:43:29 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 10:32:46 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.